Package ru.bitel.bgbilling.modules.cerbercrypt.common.service

# Interface CardActionsService

All Superinterfaces:
  `LoggableService`

    public interface CardActionsService
    extends LoggableService

1) Все действия над картами (из протокола, отправка сообщений, активации/деактивации итд, загрузка) 2) Все экшены карт - получение, апдейт. 3) Также тут экшен поиска карты (бывший ActionFindCard) 4) Также тут экшен CardTable - админка карт.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `activate​(long cardNumber)` |
  `int` | `cardDealerAdd​(java.lang.String cards, int dealerId)` | Модуль церберкрипт -> менеджер карт : передать дилеру.
  `int` | `cardDealerDelete​(java.lang.String cards)` | Модуль церберкрипт -> менеджер карт : забрать у дилера.
  `int` | `cardLoad​(java.lang.String cards, int dealerId, boolean allowEmptyPassword)` | Модуль церберкрипт -> менеджер карт: загрузить карты.
  `Result<Card>` | `cardTable​(Page page, MapHolder<java.lang.String,​java.lang.String> request)` | Таблица карт в менеджере карт.
  `void` | `customCommand​(long cardNumber, java.lang.String action, java.lang.String[] params)` | Какая-то произвольная команда слишком специфичная для какой-то CAS с параметрами.
  `void` | `deactivate​(long cardNumber)` |
  `void` | `deleteCard​(long cardNumber)` | Удаление карты в справочнике карт.
  `void` | `dosync​(long cardNumber)` | Запуск синхронизации по карте прямо сейчас.
  `Result<UserCard>` | `findCard​(Page page, Period period, long card, java.lang.String sort, java.lang.String mode)` | Поиск карты по параметрам.
  `java.util.List<java.lang.Long>` | `getAllCardNumbers()` | Возвращает номера всех карт заведённых.
  `Card` | `getCard​(long cardNumber)` |
  `java.util.List<java.lang.Long>` | `getFreeCardNumbers()` | Возвращает номера свободных карт (заведённых, но не стоящих ни в одном договоре).
  `java.lang.String` | `getPairing​(long cardNumber)` | запрос pairing с удалённого сервера. если null - то нету.
  `java.lang.String` | `getSubscribeInfo​(long cardNumber)` | Возвращает в строковом виде информацию о подписке (подразумевается, что идёт запрос с сервера).
  `void` | `pinCode​(long cardNumber, java.lang.String pinCode)` |
  `void` | `sendMessages​(java.lang.String sendMode, java.lang.String messageTitle, java.lang.String messageBody, java.lang.String receiverMode, MapHolder<java.lang.String,​java.lang.String> request)` |
  `void` | `setPairing​(long cardNumber, java.lang.String pairingModule)` | установление pairing на удалённый сервер. если pairingModule - null то типа убрать.
  `void` | `updateCard​(Card card)` |

  ### Methods inherited from interface ru.bitel.common.model.LoggableService

  `logList`

- ## Method Details

  - ### activate

    void activate​(long cardNumber) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### deactivate

    void deactivate​(long cardNumber) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### getCard

    Card getCard​(long cardNumber) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### updateCard

    void updateCard​(Card card) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### getAllCardNumbers

    java.util.List<java.lang.Long> getAllCardNumbers() throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Возвращает номера всех карт заведённых.
    Returns:
      список длинных целых чисел.
    Throws:
      `ru.bitel.bgbilling.common.BGException` - ошибка.
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getFreeCardNumbers

    java.util.List<java.lang.Long> getFreeCardNumbers() throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Возвращает номера свободных карт (заведённых, но не стоящих ни в одном договоре).
    Returns:
      список длинных целых чисел.
    Throws:
      `ru.bitel.bgbilling.common.BGException` - ошибка.
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### getSubscribeInfo

    java.lang.String getSubscribeInfo​(long cardNumber) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Возвращает в строковом виде информацию о подписке (подразумевается, что идёт запрос с сервера).
    Parameters:
      `cardNumber` - номер карты.
    Returns:
      строка (возможно, переводами строк) со справкой о подписке по этой карте.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### dosync

    void dosync​(long cardNumber) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Запуск синхронизации по карте прямо сейчас. Используется номер карты, юзеркарта вычисляется сейчас.
    Parameters:
      `cardNumber` - номер карты
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### findCard

    Result<UserCard> findCard​(Page page, Period period, long card, java.lang.String sort, java.lang.String mode) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Поиск карты по параметрам. Модуль церберкрипт -> поиск карты
    Parameters:
      `page` -
      `period` -
      `card` - номер карты
      `sort` - сортировка: contract.title,card.number,card.date1,no ("no" по дефолту)
      `mode` - режим совпадения: start,end,include,equal("equal" по дефолту)
    Returns:
      резалт с юзеркартами (заполнены не все поля)
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### cardTable

    Result<Card> cardTable​(Page page, MapHolder<java.lang.String,​java.lang.String> request) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Таблица карт в менеджере карт. Модуль церберкрипт -> менеджер карт. Бывший CardTable. Часть фильтра пока передаётся как Map ("dealer","dealer_status","contract_status","number","count").
    Parameters:
      `page` -
      `request` -
    Returns:
      таблица Card
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### cardLoad

    int cardLoad​(java.lang.String cards, int dealerId, boolean allowEmptyPassword) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Модуль церберкрипт -> менеджер карт: загрузить карты.
    Parameters:
      `dealerId` - ид дилера (если не привязывать, то должен быть 0)
      `cards` - строка карт в виде как описано в доке (перевод строки, разделение табуляцийей)
      `allowEmptyPassword` - не проверять вторую колонку на наличие, если карты хотят грузить без пароля
    Returns:
      кол-во загруженых карт.
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException` - загрузки ошибки текст, если есть.
      `ru.bitel.bgbilling.common.BGException`

  - ### cardDealerAdd

    int cardDealerAdd​(java.lang.String cards, int dealerId) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Модуль церберкрипт -> менеджер карт : передать дилеру.
    Parameters:
      `dealerId` - ид дилера.
      `cards` - список номеров карт через запятую.
    Returns:
      кол-во обработанных карт.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### cardDealerDelete

    int cardDealerDelete​(java.lang.String cards) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Модуль церберкрипт -> менеджер карт : забрать у дилера.
    Parameters:
      `dealerId` - ид дилера (не используется?).
      `cards` - список номеров карт через запятую.
    Returns:
      кол-во обработанных карт.
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### pinCode

    void pinCode​(long cardNumber, java.lang.String pinCode) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### sendMessages

    void sendMessages​(java.lang.String sendMode, java.lang.String messageTitle, java.lang.String messageBody, java.lang.String receiverMode, MapHolder<java.lang.String,​java.lang.String> request) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### getPairing

    java.lang.String getPairing​(long cardNumber) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    запрос pairing с удалённого сервера. если null - то нету.
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### setPairing

    void setPairing​(long cardNumber, java.lang.String pairingModule) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    установление pairing на удалённый сервер. если pairingModule - null то типа убрать.
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### deleteCard

    void deleteCard​(long cardNumber) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Удаление карты в справочнике карт. Проверяются всякие проверки.
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`

  - ### customCommand

    void customCommand​(long cardNumber, java.lang.String action, java.lang.String[] params) throws ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGException
    Какая-то произвольная команда слишком специфичная для какой-то CAS с параметрами.
    Parameters:
      `cardNumber` -
      `action` -
      `params` -
    Throws:
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGException`